'/*=========================================
' DotNetBips.ApplicationBlocks.Data
' Version 1.0
' Date: 19 October, 2002
' Author: Bipin Joshi (webmaster@dotnetbips.com)
'=========================================*/

Imports System.Data
Imports System.Configuration


Public NotInheritable Class DataFactory

    Public Shared Function CreateConnection() As IDbConnection
        Dim obj As AssemblyName
        Dim t As Type
        Dim a As [Assembly]
        a = a.GetExecutingAssembly
        Dim b() As AssemblyName = a.GetReferencedAssemblies()
        For Each obj In b
            If obj.Name = ConfigurationSettings.AppSettings("assembly") Then
                Dim an As [Assembly]
                an = an.Load(obj.FullName)
                t = an.GetType(ConfigurationSettings.AppSettings("connection"))
                Exit For
            End If
        Next
        Return Activator.CreateInstance(t)
    End Function

    Public Shared Function CreateCommand() As IDbCommand
        Dim obj As AssemblyName
        Dim t As Type
        Dim a As [Assembly]
        a = a.GetExecutingAssembly
        Dim b() As AssemblyName = a.GetReferencedAssemblies()
        For Each obj In b
            If obj.Name = ConfigurationSettings.AppSettings("assembly") Then
                Dim an As [Assembly]
                an = an.Load(obj.FullName)
                t = an.GetType(ConfigurationSettings.AppSettings("command"))
                Exit For
            End If
        Next
        Return Activator.CreateInstance(t)
    End Function

    Public Shared Function CreateDataAdapter() As IDbDataAdapter
        Dim obj As AssemblyName
        Dim t As Type
        Dim a As [Assembly]
        a = a.GetExecutingAssembly
        Dim b() As AssemblyName = a.GetReferencedAssemblies()
        For Each obj In b
            If obj.Name = ConfigurationSettings.AppSettings("assembly") Then
                Dim an As [Assembly]
                an = an.Load(obj.FullName)
                t = an.GetType(ConfigurationSettings.AppSettings("dataadapter"))
                Exit For
            End If
        Next
        Return Activator.CreateInstance(t)
    End Function

    Public Shared Function CreateParameter() As IDbDataParameter
        Dim obj As AssemblyName
        Dim t As Type
        Dim a As [Assembly]
        a = a.GetExecutingAssembly
        Dim b() As AssemblyName = a.GetReferencedAssemblies()
        For Each obj In b
            If obj.Name = ConfigurationSettings.AppSettings("assembly") Then
                Dim an As [Assembly]
                an = an.Load(obj.FullName)
                t = an.GetType(ConfigurationSettings.AppSettings("parameter"))
                Exit For
            End If
        Next
        Return Activator.CreateInstance(t)
    End Function

End Class
